// CallDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Chat.h"
#include "CallDlg.h"
#include "ProxyAuthDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define ID_TIMER_CONNECT	1000
/////////////////////////////////////////////////////////////////////////////
// CCallDlg dialog


CCallDlg::CCallDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCallDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCallDlg)
	m_nPort = CHAT_PORT;
	m_szServer = _T("127.0.0.1");
	m_szCallTips = _T("ȴ");
	m_bUseProxy = FALSE;
	//}}AFX_DATA_INIT
	m_pClientThread = NULL;
	m_bState = CALL_ORIGIN;
	m_bMode = FALSE;		//ô
	m_lpReceiveBuffer = NULL;
}


void CCallDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCallDlg)
	DDX_Control(pDX, IDC_CALL_PROGRESS, m_ctrlProgress);
	DDX_Text(pDX, IDC_CALL_PORT, m_nPort);
	DDV_MinMaxUInt(pDX, m_nPort, 1, 65535);
	DDX_Text(pDX, IDC_CALL_SERVER, m_szServer);
	DDV_MaxChars(pDX, m_szServer, 128);
	DDX_Text(pDX, IDC_CALL_TIP, m_szCallTips);
	DDV_MaxChars(pDX, m_szCallTips, 10);
	DDX_Check(pDX, IDC_CALL_USEPROXY, m_bUseProxy);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCallDlg, CDialog)
	//{{AFX_MSG_MAP(CCallDlg)
	ON_WM_TIMER()
	ON_MESSAGE( WM_CALL_TIMEOUT, OnCallTimeOut )
	ON_MESSAGE( WM_THREAD_QUIT, OnThreadQuit )
	ON_MESSAGE( WM_THREAD_DATA, OnThreadData )
	ON_MESSAGE( WM_THREAD_CONNECT, OnConnectOK )
	ON_MESSAGE( SOCKET_THREAD_CONNECT, OnThreadConnect )
	ON_MESSAGE( SOCKET_THREAD_RESOLVE, OnThreadResolve )
	ON_MESSAGE( SOCKET_THREAD_WRITE, OnThreadWrite )
	ON_MESSAGE( SOCKET_THREAD_TRANSFER, OnTransfer )
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCallDlg message handlers

BOOL CCallDlg::OnInitDialog() 
{

	
	m_hMainWnd = GetParent()->GetSafeHwnd();
	CDialog::OnInitDialog();	
	// TODO: Add extra initialization here
	m_ctrlProgress.ShowPercent( TRUE );
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCallDlg::OnOK() 
{
	// TODO: Add extra validation here
	//, һ,Ի,ʼ


	UpdateData();


	m_bMode = m_bUseProxy;	

	if( m_bState == CALL_ORIGIN )
	{
		//û
		//﷨
		//ԼǷô
		if( m_szServer.IsEmpty() )
		{
			MessageBox( "ΪգƻIPַ", "", MB_OK|MB_ICONSTOP );
			return;
		}
		//߳
		ASSERT( m_pClientThread == NULL );
		m_pClientThread = new CClientThread(m_szServer, m_nPort, m_bUseProxy, GetSafeHwnd(), m_hMainWnd );
		if( m_pClientThread == NULL )
		{
			MessageBox("ͻ߳ʧܣͷԴ", "", MB_OK|MB_ICONSTOP );
			return;
		}

		//ɹ
		m_pClientThread->CreateThread();
		//
		SetTimer( ID_TIMER_CONNECT, 1000, NULL );
		//ðťΪȡ
		GetDlgItem( IDOK )->SetWindowText("ȡ" );
		m_ctrlProgress.SetRange( 0, confChat.nWaitTime );
		m_ctrlProgress.SetStep(1);
		m_ctrlProgress.SetPos( 0 );
		m_bState = CALL_CONNECTING;
	}
	else
	{
		//ѡȡ
		if( m_pClientThread )
		{
			m_pClientThread->KillThread();
			m_pClientThread = NULL;
		}
		m_bState = CALL_ORIGIN;
		KillTimer( ID_TIMER_CONNECT );
		CDialog::OnCancel();
	}
}

void CCallDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default

	if( nIDEvent == ID_TIMER_CONNECT )
	{
		//ȣжǷﵽ
		m_ctrlProgress.StepIt();

		if( (UINT)m_ctrlProgress.GetPos() == confChat.nWaitTime )
		{
			//ASSERT( m_bState == CALL_CONNECTING );
			//Stop it
			PostMessage( WM_CALL_TIMEOUT, 0, 0 );
		}
	}
	CDialog::OnTimer(nIDEvent);
}


void CCallDlg::OnCallTimeOut(WPARAM wParam, LPARAM lParam)
{
	//ʱ䵽

	if( m_pClientThread  )
	{
			m_pClientThread->KillThread();
			m_pClientThread = NULL;
	}
	if( m_bState != CALL_ORIGIN )
	{
			GetDlgItem(IDOK)->SetWindowText("");
			KillTimer( ID_TIMER_CONNECT );
			m_ctrlProgress.SetPos( 0 );
			m_bState = CALL_ORIGIN;
	}
}


void CCallDlg::OnCancel()
{

	if( m_bState != CALL_ORIGIN )
	{
		// ֹͣӣ˳
		if( m_pClientThread )
		{
			m_pClientThread->KillThread();
			m_pClientThread = NULL;
		}
	}
	m_bState = CALL_ORIGIN;
	CDialog::OnCancel();
}


void CCallDlg::OnThreadConnect( WPARAM wParam, LPARAM lParam )
{
	//յϢ
	// wParamsocket
	// HIWORD(lParam)Ǵ
	// LOWORD(lParam)ϢFD_CONNECT
	int nError=HIWORD(lParam);

	//Clienṯ߳ͬ	
	CSingleLock single( &g_cMutexClient );
	single.Lock();

	if( m_bState != CALL_CONNECTING ) return;
	if( m_pClientThread == NULL ) return;
	if( (SOCKET)wParam != m_pClientThread->GetSocket() ) return;

	//ӳɹ
	
	m_pClientThread->OnSocketConnect();

	switch( nError )
	{
	case 0:
		if( m_bMode == FALSE )
		{
				//ѾӺãͨ
				KillTimer( ID_TIMER_CONNECT );
				//ȴ̷߳ WM_THREAD_CONNECTϢ
				return;
		}
		//Proxy׼
		if( m_lpReceiveBuffer == NULL )
			m_lpReceiveBuffer = (LPBYTE)GlobalAlloc( GPTR, 
								MAX_PACKET_SIZE*2 );
		break;
	case WSAECONNREFUSED:
		//ֹͣ߳
		KillTimer( ID_TIMER_CONNECT );
		m_pClientThread->KillThread();
		m_pClientThread = NULL;
		MessageBox( "ԷѾṩ", "", MB_OK|MB_ICONSTOP );
		break;
	case WSAETIMEDOUT:
		KillTimer( ID_TIMER_CONNECT );
		m_pClientThread->KillThread();
		m_pClientThread = NULL;
		MessageBox( "ָ޷ӣ롣", "", MB_OK|MB_ICONSTOP );
		break;
	default: 
		CString szTemp;
		KillTimer( ID_TIMER_CONNECT );
		szTemp.Format( "SOCKETӷش룺%d", nError );
		MessageBox( szTemp, "", MB_OK|MB_ICONSTOP );
		m_pClientThread->KillThread();
		m_pClientThread = NULL;
		break;
	}
}

void CCallDlg::OnThreadQuit( WPARAM wParam, LPARAM lParam )
{
	//յ˳Ϣ
	int nError = LOWORD(lParam);

	//Clienṯ߳ͬ	
	CSingleLock single( &g_cMutexClient );
	single.Lock();

	if( !wParam  )
	{
		//
		//ASSERT( m_pClientThread != NULL );
		KillTimer( ID_TIMER_CONNECT );
		if( m_pClientThread )
		{
			m_pClientThread->KillThread();
			m_pClientThread = NULL;
		}
		//m_pClientThread=NULL;
		GetDlgItem(IDOK)->SetWindowText("");
		m_ctrlProgress.SetPos(0);
		m_bState = CALL_ORIGIN;

		switch( nError )
		{
		case SOCKET_ERROR_REFUSE:
			MessageBox( "ԷѾṩ", "", MB_OK|MB_ICONSTOP );
			break;
		case SOCKET_ERROR_TIMEOUT:
			MessageBox( "ָ޷ӣ롣", "", MB_OK|MB_ICONSTOP );
			break;
		default: break;

		}

	}
}


void CCallDlg::OnThreadResolve(WPARAM wParam, LPARAM lParam )
{
	//õϢ

	if( m_pClientThread )
	{
		m_pClientThread->OnSocketConnect();
	}
}

void CCallDlg::OnThreadWrite( WPARAM wParam, LPARAM lParam )
{
		//ȻȺӦ
		//ݽзڽж
		int bSuccess = (int)wParam;
		int nResult = (int)lParam;


		if( bSuccess == TRUE ) return;
		switch( nResult )
		{
		case SOCKET_ERROR_NOERROR:
			//ͳɹȺ
			m_bState = CALL_WAITING;
			break;
		case SOCKET_ERROR_RESET:
			MessageBox( "ͨãӡ", "", MB_OK|MB_ICONSTOP );
			m_bState = CALL_CONNECTED;
			OnCancel();
			break;
		case SOCKET_ERROR_CLOSE:
			MessageBox("ͨ쳣رգӡ", "", MB_OK|MB_ICONSTOP );
			m_bState = CALL_CONNECTED;
			OnCancel();
			break;
		default:
			MessageBox("ʱ", "", MB_OK|MB_ICONSTOP );
			m_bState = CALL_CONNECTED;
			OnCancel();
			break;
		}	
}


void CCallDlg::OnTransfer(WPARAM wParam, LPARAM lParam )
{
	//յFD_READFD_WRITEFD_CLOSEϢ
	int nError = HIWORD(lParam);
	int nMessage=LOWORD(lParam);

	//Clienṯ߳ͬ	
	CSingleLock single( &g_cMutexClient );
	single.Lock();

	if( m_pClientThread == NULL ) return;
	if( wParam == m_pClientThread->GetSocket() )
	{
		if( nError == 0 )
		{
			if( nMessage == FD_READ )
			{
				::PostThreadMessage( m_pClientThread->m_nThreadID,
					SOCKET_THREAD_READ, 0, 0 );
			}
			else if(nMessage == FD_WRITE )
			{
				::PostThreadMessage( m_pClientThread->m_nThreadID,
					SOCKET_THREAD_WRITE, 0, 0 );
			}
			else if( nMessage == FD_CLOSE )
			{
				//ر
				if( m_bState == CALL_WAITING )
				{
					//ûݾ͹
					MessageBox("رӣԡ", "", MB_OK|MB_ICONSTOP );
				}
				if( m_pClientThread )
				{
					m_pClientThread->KillThread();
					m_pClientThread = NULL;
				}
				m_bState = CALL_ORIGIN;
				m_ctrlProgress.SetPos(0);
				KillTimer( ID_TIMER_CONNECT );
				GetDlgItem(IDOK)->SetWindowText("" );
			}
		}
	}
}


void CCallDlg::OnThreadData(WPARAM wParam, LPARAM lParam )
{
	//յ̷߳ݶϢ
	//Ӧ
	int nBytes = (int)wParam;
	LPCTSTR lpTemp = (LPCTSTR)m_lpReceiveBuffer;
	CProxyAuthDlg	*pDlg = NULL;
	int nResult;
	CString szPassword;
	char	pBaseCode[512];

	//Clienṯ߳ͬ	
	CSingleLock single( &g_cMutexClient );
	single.Lock();


	memcpy( m_lpReceiveBuffer, (LPBYTE)lParam, nBytes );

	//Ӧ HTTP 200 OKͺ
	//Կ¹ҽϢ

	////////////////////////////////////////////////
	/////////	HTTP 200
	/////////   ѾӺ
	////////////////////////////////////////////////
	if( strstr( lpTemp, "HTTP/1.0 200 ") != NULL )
	{
		if( confChat.bProxyUsable == PROXY_AUTH_UNSET )
		{
			confChat.bProxyUsable = PROXY_AUTH_NOPASS;
		}
		else	confChat.bProxyUsable = PROXY_AUTH_SETPASS;
		//ӾͿ

		//¹ҽϢ
		if( m_pClientThread )
		{
			nResult = m_pClientThread->ChangeHandle();
			if( nResult == FALSE )
			{
				m_bState = CALL_DISCONNECT;
				MessageBox("ܺʹڰϢӡ", "", MB_OK|MB_ICONSTOP );
				OnCancel();
				return;
			}
			if( m_lpReceiveBuffer ) GlobalFree( m_lpReceiveBuffer );
			CDialog::OnOK();
		}
		return ;
	}

	////////////////////////////////////////////////
	/////////	HTTP 407
	/////////	Ҫ
	////////////////////////////////////////////////

	if( strstr( lpTemp, "HTTP/1.0 407 ") != NULL )
	{
		pDlg = new CProxyAuthDlg;
		if( pDlg != NULL )
		{
			//ϴ
			pDlg->m_szUserName = confChat.szProxyUser;
			pDlg->m_szProxy = confChat.szProxyIP;
			nResult = pDlg->DoModal();
			if( nResult != IDOK )
			{
				delete pDlg;
				return ;
			}
			//þֲ
			confChat.szProxyUser = pDlg->m_szUserName;
			szPassword = pDlg->m_szPass;
			confChat.bProxyUsable = PROXY_AUTH_SETTING;
			delete pDlg;
		
			// ύٴ
			// BASE64
			memset( pBaseCode ,0, 512 );
			HTTPAuth( (LPSTR)(LPCTSTR)confChat.szProxyUser, (LPSTR)(LPCTSTR)szPassword, pBaseCode );
			confChat.szProxyPass.Format( "%s", pBaseCode );
			// ٴԶ̷
			//ж̣߳һµ
			if( m_pClientThread != NULL )
			{
				m_pClientThread->KillThread();
				m_pClientThread = NULL;
			}

			m_pClientThread = new CClientThread(m_szServer, m_nPort, m_bUseProxy, GetSafeHwnd(), m_hMainWnd );
			if( m_pClientThread == NULL )
			{
				MessageBox("ͻ߳ʧܣͷԴ", "", MB_OK|MB_ICONSTOP );
				return;
			}

			//ɹ
			m_pClientThread->CreateThread();
			m_bState = CALL_CONNECTING;
			//¼
			KillTimer( ID_TIMER_CONNECT );
			m_ctrlProgress.SetPos(0);
			SetTimer( ID_TIMER_CONNECT, 1000, NULL );
			GetDlgItem( IDOK )->SetWindowText("ȡ");
			return;
		}
		OnCancel();
		return;
	}
	
	////////////////////////////////////////////////
	/////////	HTTP 403 
	/////////	ֹ
	////////////////////////////////////////////////
	if( strstr( lpTemp, "HTTP/1.0 403 ") != NULL )
	{
		MessageBox("󱻴ܾӡ", "", MB_OK|MB_ICONSTOP );
		m_bState = CALL_CONNECTING;
		OnCancel();
		return;
	}
	//MessageBox("ΪЧϵԱ", "", MB_OK|MB_ICONSTOP );
	//m_bState = CALL_CONNECTING;
	//OnCancel();
	//return;
}

void CCallDlg::HTTPAuth(char *uid, char *pass, char *outbuf)
{
	char temp[512];
	char buf[256];
	int ret = -1;

	memset(buf,0,256);
	memset(temp,0,512);

	memcpy(buf,uid,strlen(uid));
	memcpy(buf+strlen(uid),":",1);
	memcpy(buf+strlen(uid)+1,pass,strlen(pass));

	Base64Code(buf,temp);
	strcpy(outbuf,HTTP_AUTH_HEAD);
	strcat(outbuf+strlen(HTTP_AUTH_HEAD),temp);
	ret = strlen(outbuf) ;
}

void CCallDlg::Base64Code(char *inbuf, char *outbuf)
{
	int ret = -1 ;
	int i = 0 ;
	int remain;
	int oneout;
	int num;
	int c = 0 ;
	int now;
	char CODETABLE[65]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	
	if ( *inbuf <= 0 )
	{
		goto end;
	}
	num = 8 ;
	remain = *inbuf;
	oneout = 0 ;
	now = 0 ;
	while ( 1 )
	{
		while ( num >= 6 )
		{
			oneout = ( remain >> (num-6) ) & 0x3f ;
			memcpy( outbuf+now, &CODETABLE[oneout] , 1 );
			now++;
			num -=6;
			if ( num == 2 )
				c = 0x0300;
			else
				if ( num == 4 )
					c = 0x0f00;
				else
					if ( num == 6 )
						c = 0x3f00;
					else
						c = 0x0000;
			if ( num != 6 )
				remain = ( remain <<8 ) & c ;
		}
		if ( *(++inbuf)==NULL )
			break;
		if ( num == 2 )
			c = 0x03ff;
		else
			if ( num == 4 )
				c = 0x0fff;
			else
				c = 0x00ff;
		remain = ( remain | ( *inbuf & 0x00ff ) ) & c ;
		num+=8;
	}
	if  ( ( num < 6 ) && ( num != 0 ) ) 
	{
		remain = remain >> 8 ;
		remain = ( remain <<( 6 - num )) & 0x00003f;
		memcpy( outbuf+now, &CODETABLE[remain] , 1 ) ;
		now++;
		memcpy( outbuf+now, "==" ,  6/2 - num/2 ) ;
		now +=6/2 - num/2;
	}
	ret = 0 ;
end:
	return;
}


void CCallDlg::OnConnectOK(WPARAM wParam, LPARAM lParam)
{

	//Clienṯ߳ͬ	
	CSingleLock single( &g_cMutexClient );
	single.Lock();

	if( m_bState != CALL_CONNECTING ) return;
	m_bState = CALL_CONNECTED;
	//Proxyͨ
	if( m_bMode == TRUE ) return;
	//ѾյӺõϢ
	if( m_lpReceiveBuffer != NULL )
	{
		GlobalFree( m_lpReceiveBuffer );
		m_lpReceiveBuffer = NULL;
	}
	m_bState = CALL_CONNECTED;

	CDialog::OnOK();
}