// ChatDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Chat.h"
#include "ChatDlg.h"
#include "ProxyAuthDlg.h"
#include "CallDlg.h"
#include "OptionDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define ID_TIMER_SENDPROXY WM_USER+2000
#define ID_TIMER_CHAT	   WM_USER+2001

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChatDlg dialog

CChatDlg::CChatDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChatDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChatDlg)
	m_szChatSend = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bType = IAM_NULL;
	m_pClientThread = NULL;
	m_pServerThread = NULL;
	m_lpReceiveBuffer = NULL;
	m_lpSendBuffer = NULL;
	m_bState = MY_ORIGIN;
	m_bHaveGotName = FALSE;

}

void CChatDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChatDlg)
	DDX_Control(pDX, IDC_CHAT_LIST, m_ctrlChat);
	DDX_Text(pDX, IDC_CHAT, m_szChatSend);
	DDV_MaxChars(pDX, m_szChatSend, 160);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CChatDlg, CDialog)
	//{{AFX_MSG_MAP(CChatDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_COMMAND(ID_FILE_OPTION, OnFileOption)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_SEND, OnSend)
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnect)
	ON_WM_TIMER()
	ON_MESSAGE( SOCKET_THREAD_ACCEPT, OnClientAccept )
	ON_MESSAGE( WM_THREAD_QUIT, OnThreadQuit )
	ON_MESSAGE( WM_THREAD_DATA, OnThreadData )
	ON_MESSAGE( SOCKET_THREAD_WRITE, OnThreadWrite )
	ON_MESSAGE( SOCKET_THREAD_TRANSFER, OnTransfer )
	ON_COMMAND(ID_FILE_ABOUT, OnFileAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChatDlg message handlers

BOOL CChatDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_lpReceiveBuffer = (LPBYTE)GlobalAlloc( GPTR, MAX_PACKET_SIZE*4 );
	if( !m_lpReceiveBuffer )
	{
		MessageBox( "Դ㣬ܷ洢ռ䡣","", MB_OK|MB_ICONSTOP);
	}
	else
	{
		m_lpSendBuffer = (LPBYTE)GlobalAlloc( GPTR, MAX_PACKET_SIZE+1 );
		if( !m_lpSendBuffer )
		{
			MessageBox( "Դ㣬ܷ洢ռ䡣","", MB_OK|MB_ICONSTOP);
		}
	}


	InitProfile();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	if( confChat.szLocalIP == _T("127.0.0.1") )GetLocalIP();

	//
	ASSERT( m_pServerThread == NULL );
	m_pServerThread = new CServerThread( GetSafeHwnd(), confChat.nServicePort );
	if( m_pServerThread == NULL )
	{
		MessageBox("޷̣߳ͷԴ", "", MB_OK|MB_ICONSTOP );
		return TRUE;
	}
	m_pServerThread->CreateThread();

	GetDlgItem(IDC_DISCONNECT)->EnableWindow( FALSE );
	GetDlgItem(IDC_CHAT )->EnableWindow(FALSE );
	GetDlgItem(IDC_SEND )->EnableWindow(FALSE );

	SetDefID( IDC_SEND );
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CChatDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else if( nID == SC_CLOSE)
	{
			OnFileExit();
	}
	else if( nID != SC_MAXIMIZE  )
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CChatDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CChatDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CChatDlg::OnFileExit() 
{
	// TODO: Add your command handler code here
	int nResult;

	if( m_bType == IAM_CLIENT )
	{
		nResult =  MessageBox("ѾͶԷӺãȷ˳", "", MB_OKCANCEL|MB_ICONQUESTION );
		if( nResult != IDOK ) return;
	}
	else if( m_bType == IAM_SERVER )
	{
		nResult =  MessageBox("Ѿ˺Ӻãȷ˳", "", MB_OKCANCEL|MB_ICONQUESTION );
		if( nResult != IDOK ) return;
	}

	//Ȼ߳ڻ
	if( m_bType != IAM_NULL )
		OnDisconnect();

	if( m_pServerThread != NULL )
	{
		m_pServerThread->KillThread();
		m_pServerThread = NULL;
	}

	WriteProfile();

	if( !m_lpReceiveBuffer ) GlobalFree( m_lpReceiveBuffer );
	if( !m_lpSendBuffer ) GlobalFree( m_lpSendBuffer );



	DestroyWindow();		
}

void CChatDlg::OnFileOption() 
{
	// TODO: Add your command handler code here
	COptionDlg *pDlg = new COptionDlg;
	if( pDlg )
	{
		//Щ
		pDlg->m_bUseProxy = confChat.bUseProxy;
		pDlg->m_nProxyPort = confChat.nProxyPort;
		pDlg->m_nProxyType = confChat.nProxyType;

		if( confChat.nWaitTime < 30 ) confChat.nWaitTime = 30;
		else if( confChat.nWaitTime >90 ) confChat.nWaitTime = 90;
		pDlg->m_nWaitTime = (int)((confChat.nWaitTime-30)/30);

		pDlg->m_szIP = confChat.szLocalIP;
		pDlg->m_szProxy = confChat.szProxyIP;
		pDlg->m_nServicePort = confChat.nServicePort;
		pDlg->m_szName = confChat.szUserName;

		if( pDlg->DoModal() == IDOK )
		{

			confChat.bUseProxy = pDlg->m_bUseProxy;
			confChat.nProxyPort = pDlg->m_nProxyPort;
			confChat.nProxyType = pDlg->m_nProxyType;
			confChat.nWaitTime = (pDlg->m_nWaitTime+1)*30;

			confChat.szLocalIP = pDlg->m_szIP;
			confChat.szProxyIP = pDlg->m_szProxy;
			confChat.nServicePort = pDlg->m_nServicePort;
			if( pDlg->m_szName.GetLength() == 0 ) pDlg->m_szName = _T("UNKNOWN");
			if( confChat.szUserName != pDlg->m_szName )
			{
				confChat.szUserName = pDlg->m_szName;
				if( m_bType != IAM_NULL )
				{
					SendCommand( CHAT_ACT_SEND_NAME );
				}
				m_ctrlChat.SetMyName( pDlg->m_szName );
			}
			else confChat.szUserName = pDlg->m_szName;
		}

		delete pDlg;
	}
}

void CChatDlg::OnFileSave() 
{
	// TODO: Add your command handler code here
	int nResult;
	CString szFileName;
	char pTemp[_MAX_PATH+1];
	FILE *fp;

	if( m_ctrlChat.GetBytes() == 0 ) 
	{
		MessageBox("ûݣܱ档", "", MB_OK|MB_ICONSTOP );
		return;
	}

	if( m_ctrlChat.GetBuffer() == NULL )
	{
		MessageBox("ûݣܱ档", "", MB_OK|MB_ICONSTOP );
		return;
	}

	GetCurrentDirectory( _MAX_PATH, pTemp );

	//ѡ񱣴·
	CFileDialog *pDlg = new CFileDialog(FALSE, "txt",  NULL, 
									OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
									" (*.txt)|*.txt|", this );

	pDlg->m_ofn.lpstrInitialDir = pTemp;

	if( pDlg )
	{
		nResult = pDlg->DoModal();
		szFileName = pDlg->GetPathName();
		delete pDlg;
		if( nResult == IDOK )
		{
			fp = fopen( (LPCTSTR)szFileName, "wt");
			if( fp )
			{
				//д
				fwrite( m_ctrlChat.GetBuffer(), m_ctrlChat.GetBytes(), 1, fp );
				fprintf(fp, "\n" );
				fclose(fp);
			}
		}
	}
}

void CChatDlg::InitProfile()
{
	CWinApp *pTheApp = AfxGetApp();

	//粿
	confChat.bUseProxy	= pTheApp->GetProfileInt( "Network", "UseProxy", FALSE );
	confChat.nProxyType	= pTheApp->GetProfileInt( "Network", "ProxyType", HTTP_PROXY );
	confChat.szProxyIP	= pTheApp->GetProfileString( "Network", "ProxyIP", "127.0.0.1" );
	confChat.nProxyPort	= pTheApp->GetProfileInt( "Network", "ProxyPort", 8080 );
	confChat.bProxyUsable	= PROXY_AUTH_UNSET;
	confChat.szProxyPass	= _T("UNKNOWN");
	confChat.szProxyUser	= _T("");

	//Server
	confChat.nServicePort	= pTheApp->GetProfileInt( "Server", "ServicePort", CHAT_PORT );
	confChat.szLocalIP	= pTheApp->GetProfileString( "Server", "LocalIP", "127.0.0.1" );

	//Client
	confChat.nWaitTime	= pTheApp->GetProfileInt( "Client", "WaitTime", 30 );
	confChat.szLastCallHost = pTheApp->GetProfileString( "Client", "LastCallHost", "");
	confChat.nLastCallPort = pTheApp->GetProfileInt( "Client", "LastCallPort", CHAT_PORT);
	

	//information
	confChat.szUserName	 = pTheApp->GetProfileString( "Information", "UserName", "Annoymous" );

	confChat.bWinsockReady = FALSE;

}

void CChatDlg::WriteProfile()
{
	CWinApp *pTheApp = AfxGetApp();

	UpdateData();

	//粿
	pTheApp->WriteProfileInt( "Network", "UseProxy",	confChat.bUseProxy );
	pTheApp->WriteProfileInt( "Network", "ProxyType",	confChat.nProxyType );
	pTheApp->WriteProfileString( "Network", "ProxyIP",	confChat.szProxyIP );
	pTheApp->WriteProfileInt( "Network", "ProxyPort",	confChat.nProxyPort );


	//Server
	pTheApp->WriteProfileInt( "Server", "ServicePort",	confChat.nServicePort );
	pTheApp->WriteProfileString( "Server", "LocalIP",	confChat.szLocalIP );

	//Client
	pTheApp->WriteProfileInt( "Client", "WaitTime",		confChat.nWaitTime );
	pTheApp->WriteProfileString( "Client", "LastCallHost",		confChat.szLastCallHost );
	pTheApp->WriteProfileInt( "Client", "LastCallPort",		confChat.nLastCallPort );

	//information
	pTheApp->WriteProfileString( "Information", "UserName", confChat.szUserName );
}

void CChatDlg::GetLocalIP()
{
	char buf[108];
	struct hostent *ip;
	if( confChat.bWinsockReady == TRUE )
	{
		if( gethostname( buf, 108 ) != 0 ) return;
		ip = gethostbyname( buf );
		if( ip != NULL )
		{
			confChat.szLocalIP.Format("%s", inet_ntoa(  *(LPIN_ADDR)(ip->h_addr_list[0]) ) );
		}
	}
}

void CChatDlg::OnOK() 
{
	// TODO: Add extra validation here
	OnFileExit();
}

void CChatDlg::OnCancel()
{

}


void CChatDlg::OnConnect() 
{
	// TODO: Add your control notification handler code here
		HWND hWnd;
	int nResult;

	if( m_bType == IAM_NULL )
	{

		hWnd = GetSafeHwnd();

		if( m_pClientThread != NULL )  
		{

			return;
		}

		CCallDlg *pDlg = new CCallDlg;
		if( pDlg )
		{
			pDlg->m_bUseProxy = confChat.bUseProxy;
			pDlg->m_nPort = confChat.nLastCallPort;;
			pDlg->m_szServer = confChat.szLastCallHost;
			nResult = pDlg->DoModal();
			if( nResult == IDOK )
			{
				//ѾӺ
				ASSERT( pDlg->m_pClientThread != NULL );
		
				GetDlgItem( IDC_CHAT_LIST )->SetWindowText(_T("") );
				GetDlgItem( IDC_CONNECT)->SetWindowText("" );				
				GetDlgItem(IDC_DISCONNECT)->EnableWindow( TRUE );
				

				confChat.nLastCallPort = pDlg->m_nPort;
				confChat.szLastCallHost = pDlg->m_szServer;

				m_pClientThread = pDlg->m_pClientThread;	
				

				m_bState = MY_CONNECTED;			
				m_bType = IAM_CLIENT;
				m_bCanWrite = TRUE;
				m_bHaveGotName = FALSE;

				if( pDlg->m_bUseProxy ) SetTimer( ID_TIMER_SENDPROXY, 30000, NULL);
				SendCommand( CHAT_ACT_SEND_NAME );

			}
			delete pDlg;
		}
		return;
	} // IAM_NULL
	
	//
	SendCommand( CHAT_ACT_ASK_TEST );
	m_bState = MY_ASKING;
}

void CChatDlg::OnSend() 
{
	// TODO: Add your control notification handler code here
	int nLen;
	UpdateData();

	if( m_bType == IAM_NULL ) return;
	nLen = m_szChatSend.GetLength();
	if( nLen == 0 ) 
	{
		GetDlgItem( IDC_CHAT )->SetFocus();
		return;
	}

	SendCommand( CHAT_ACT_ASK_SEND );
	m_bState = MY_ASKING;	
	GetDlgItem( IDC_SEND )->EnableWindow(FALSE );
	m_ctrlChat.PostChat( (LPSTR)(LPCTSTR)m_szChatSend, TRUE );
	GetDlgItem( IDC_CHAT )->SetWindowText(_T("") );
	GetDlgItem( IDC_CHAT )->SetFocus();
}

void CChatDlg::OnDisconnect() 
{
	// TODO: Add your control notification handler code here
	if( m_bState == MY_ORIGIN ) return;
	SendCommand( CHAT_ACT_QUIT );
	if( m_pClientThread )
	{
		m_pClientThread->KillThread();
		m_pClientThread = NULL;
	}
	else 
	{
		if( m_pServerThread )
			::PostThreadMessage( m_pServerThread->m_nThreadID,
					SOCKET_THREAD_SHUT, 0, 0 );
	}

	GetDlgItem(IDC_DISCONNECT)->EnableWindow( FALSE );
	GetDlgItem(IDC_CHAT )->EnableWindow(FALSE );
	GetDlgItem(IDC_SEND )->EnableWindow(FALSE );	
	GetDlgItem(IDC_CONNECT)->SetWindowText("");
	GetDlgItem(IDC_FROMIP )->SetWindowText( _T("") );
	GetDlgItem(IDC_YOUNAME)->SetWindowText( _T("") );
	GetDlgItem(IDC_TIME)->SetWindowText( _T("") );

	m_bState = MY_ORIGIN;
	m_bType = IAM_NULL;
	m_bHaveGotName = FALSE;

	KillTimer( ID_TIMER_SENDPROXY );
	KillTimer( ID_TIMER_CHAT );
}

void CChatDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if( nIDEvent == ID_TIMER_SENDPROXY )
	{
		if( m_bType == IAM_CLIENT )SendCommand( CHAT_ACT_NULL );
		else KillTimer( ID_TIMER_SENDPROXY );
	}
	else if( nIDEvent == ID_TIMER_CHAT )
	{
		if( m_bType == IAM_NULL ) 
			KillTimer( ID_TIMER_CHAT );
		//ʱ
		CTime cCurTime = CTime::GetCurrentTime();
		time_t t_cur = cCurTime.GetTime();
		CTimeSpan cSub(t_cur-t_start);
		CString szTemp = cSub.Format("%H:%M:%S" );
		GetDlgItem( IDC_TIME)->SetWindowText( szTemp );
	}
	CDialog::OnTimer(nIDEvent);
}

void CChatDlg::SendCommand(int nAct, int nBytes, LPCTSTR lpszChat)
{
	//nActǶ
	int nLen;

	if( m_bType == IAM_NULL ) return;
	if( m_bCanWrite == FALSE ) return;
	UpdateData();

	switch( nAct )
	{
	case CHAT_ACT_SEND_NAME:
		//
		m_lpSendBuffer[0] = (BYTE)nAct;
		nLen = confChat.szUserName.GetLength();
		m_lpSendBuffer[1] = (BYTE)(nLen+2);
		memcpy( m_lpSendBuffer+2, (LPCTSTR)confChat.szUserName, nLen );
		nLen+=2;
		break;
	case CHAT_ACT_ASK_SEND:
		//
		nLen = m_szChatSend.GetLength();
		if( nLen == 0 ) {return;}

		m_lpSendBuffer[0] = (BYTE)nAct;		
		m_lpSendBuffer[1] = (BYTE)(nLen+2 );
		memcpy( m_lpSendBuffer+2, (LPCTSTR)m_szChatSend, nLen );
		nLen+=2;
		break;
	case CHAT_ACT_QUIT:
	case CHAT_ACT_NULL:
	case CHAT_ACT_AGREE_TEST:
	case CHAT_ACT_ASK_TEST:
	case CHAT_ACT_AGREE_SEND:
	case CHAT_ACT_BUSY:
		m_lpSendBuffer[0] = (BYTE)nAct;
		nLen = 1;
		break;
	default: return;
	}

	if( nLen == 0 ) return;
	if( m_pClientThread )
	{
		PostThreadMessage( 
				m_pClientThread->m_nThreadID,
				WM_THREAD_DATA,
				nLen,
				(LPARAM)m_lpSendBuffer
			);
		m_bCanWrite = FALSE;
	}
	else
	{
		if( m_pServerThread )
		{
			PostThreadMessage( 
				m_pServerThread->m_nThreadID,
				WM_THREAD_DATA,
				nLen,
				(LPARAM)m_lpSendBuffer
			);
			m_bCanWrite = FALSE;
		}
	}
}


void CChatDlg::OnTransfer( WPARAM wParam, LPARAM lParam )
{
	SOCKET s=(SOCKET)wParam;
	int nError = HIWORD(lParam);
	int nMessage = LOWORD(lParam);
	int nSendMessage;

	if( m_bType == IAM_NULL ) return;

	if( m_bType == IAM_CLIENT)
	{
		CSingleLock single(&g_cMutexClient );
		single.Lock();
	}
	else 
	{
		CSingleLock single(&g_cMutexServer );
		single.Lock();
	}

	

	if( s == INVALID_SOCKET ) return;

	if( m_bType == IAM_CLIENT )
	{
		if( m_pClientThread == NULL ) return;
		if( s != m_pClientThread->GetSocket() ) return;
		//ͻ˵Ϣ
		

		if( nError == 0 )
		{
			if( nMessage == FD_READ ) nSendMessage = SOCKET_THREAD_READ;
			else if( nMessage == FD_WRITE ) 
			{
				nSendMessage = SOCKET_THREAD_WRITE;
				m_bCanWrite = TRUE;
			}
			else if (nMessage == FD_CLOSE ) 
			{
				if( m_bType==IAM_CLIENT )
				{
					//ʱϵӦÿλָ
					MessageBox("ͻģ鷢жϣӡ", "", MB_OK|MB_ICONSTOP );
				}
				nSendMessage = SOCKET_THREAD_CLOSE;
			}
			else 
			{
				return;
			}
			PostThreadMessage( 
					m_pClientThread->m_nThreadID,
					nSendMessage, 0, 0 );
		}
		//ִ󣬸ݴ֪ͨ߳
		return;
	}

	if( m_pServerThread == NULL )  return;

	if( s == m_pServerThread->GetSocket() )
	{
		if( nError == 0 )
		{
			if( nMessage == FD_READ ) nSendMessage = SOCKET_THREAD_READ;
			else if( nMessage == FD_WRITE )
			{
				m_bCanWrite = TRUE;
				nSendMessage = SOCKET_THREAD_WRITE;
			}
			else if (nMessage == FD_CLOSE ) 
			{
				if( (m_bType==IAM_SERVER) && (m_bState==MY_ORIGIN) )
				{
					
					MessageBox("ģ鷢жϣӡ", "", MB_OK|MB_ICONSTOP );
				}
				nSendMessage = SOCKET_THREAD_CLOSE;
				//
				
				GetDlgItem(IDC_DISCONNECT)->EnableWindow( FALSE );
				GetDlgItem(IDC_CHAT )->EnableWindow(FALSE );
				GetDlgItem(IDC_SEND )->EnableWindow(FALSE );	
				GetDlgItem(IDC_CONNECT)->SetWindowText("");
				GetDlgItem(IDC_FROMIP )->SetWindowText( _T("") );
				GetDlgItem(IDC_YOUNAME)->SetWindowText( _T("") );
				GetDlgItem(IDC_TIME)->SetWindowText( _T("") );
				
				m_bState = MY_ORIGIN;
				m_bType = IAM_NULL;
				m_bHaveGotName = FALSE;

				KillTimer( ID_TIMER_CHAT );
			}
			else 
			{
				return;
			}
			PostThreadMessage( 
					m_pServerThread->m_nThreadID,
					nSendMessage, 0, 0 );
		}
		//ִ󣬸ݴ֪ͨ߳
	}

}


void CChatDlg::OnClientAccept( WPARAM wParam, LPARAM lParam )
{
	SOCKET s=(SOCKET)wParam;
	int nError = HIWORD(lParam);
	int nMessage = LOWORD(lParam);

	//Serveṟ߳ͬ	
	CSingleLock single( &g_cMutexServer );
	single.Lock();
	
	
	if( s == INVALID_SOCKET ) return;
	if( m_pServerThread == NULL ) return;
	if(s != m_pServerThread->GetListenSocket() )return;
	if( nMessage == FD_ACCEPT )
	{
		//յЧϢ
		if( nError == 0 )
		{
			//֪ͨ߳̽
			if( m_pServerThread )
			{
				if( m_bState == IAM_NULL )PostThreadMessage( m_pServerThread->m_nThreadID, SOCKET_THREAD_CONNECT, TRUE, 0 );
				else PostThreadMessage( m_pServerThread->m_nThreadID, SOCKET_THREAD_CONNECT, FALSE, 0 );


				GetDlgItem( IDC_CONNECT)->SetWindowText("" );				
				GetDlgItem(IDC_DISCONNECT)->EnableWindow( TRUE );				
				GetDlgItem( IDC_CHAT_LIST )->SetWindowText(_T("") );
				m_bState = MY_CONNECTED;				
				m_bType = IAM_SERVER;
				m_bHaveGotName = FALSE;
			}
			return;
		}
	}
}

void CChatDlg::OnThreadQuit( WPARAM wParam, LPARAM lParam )
{
	int nError = LOWORD(lParam);
	BOOL IsServer = HIWORD(lParam);
	int  nResult;

	

	if( !wParam )
	{
		//ִ
		if( IsServer )
		{
			CSingleLock single( &g_cMutexServer );
			single.Lock();
			//Server˳ָ
			ASSERT( m_pServerThread != NULL );
			m_pServerThread->KillThread();
			m_pServerThread = NULL;
			CString szError;
			szError.Format( "ģֵΪ%dעⲻҪChatǷ", nError );
			nResult = MessageBox( szError, "", MB_OKCANCEL|MB_ICONINFORMATION );
			if( nResult == IDOK )
			{
				m_pServerThread = new CServerThread( GetSafeHwnd(), confChat.nServicePort );
				if( m_pServerThread == NULL )
				{
					MessageBox("޷̣߳ͷԴ", "", MB_OK|MB_ICONSTOP );
					return;
				}
				m_pServerThread->CreateThread();
				SetWindowText( "Net Chat v0.1" );
				return;
			}
			SetWindowText( "Net Chat v0.1 ----û" );
			return;
		}
		//ͻ̷߳˳
		CSingleLock single1( &g_cMutexClient );
		single1.Lock();
		ASSERT( m_pClientThread != NULL );
		m_pClientThread->KillThread();
		m_pClientThread = NULL;


		GetDlgItem(IDC_DISCONNECT)->EnableWindow( FALSE );
		GetDlgItem(IDC_CHAT )->EnableWindow(FALSE );
		GetDlgItem(IDC_SEND )->EnableWindow(FALSE );	
		GetDlgItem(IDC_CONNECT)->SetWindowText("");
		GetDlgItem(IDC_FROMIP )->SetWindowText( _T("") );
		GetDlgItem(IDC_YOUNAME)->SetWindowText( _T("") );
		GetDlgItem(IDC_TIME)->SetWindowText( _T("") );
		

		m_bState = MY_ORIGIN;
		m_bType = IAM_NULL;
		m_bHaveGotName = FALSE;

		KillTimer( ID_TIMER_SENDPROXY );
		KillTimer( ID_TIMER_CHAT );

	}
}



void CChatDlg::OnThreadData(WPARAM wParam, LPARAM lParam)
{
	//յ̷߳
	//
	//wParamֽ
	//lParamָ
	int nBytes = wParam;
	LPBYTE lpBuf = (LPBYTE)lParam;
	//ݺ
	UpdateData();

	if( m_bType == IAM_CLIENT)
	{
		CSingleLock single(&g_cMutexClient );
		single.Lock();
	}
	else 
	{
		CSingleLock single(&g_cMutexServer );
		single.Lock();
	}

	memcpy( m_lpReceiveBuffer, lpBuf, nBytes );
	AnalyzeData( m_lpReceiveBuffer, nBytes );
}



void CChatDlg::OnThreadWrite(WPARAM wParam, LPARAM lParam)
{
	//дݵ
	int nResult=(int)lParam;
	int bSuccess = (int)wParam;


	if( m_bType == IAM_NULL ) return;

	if( m_bType == IAM_CLIENT)
	{
		CSingleLock single(&g_cMutexClient );
		single.Lock();
	}
	else 
	{
		CSingleLock single(&g_cMutexServer );
		single.Lock();
	}

	if( bSuccess ) { m_bCanWrite = TRUE; }
	else
	{
			switch( nResult )
			{
			case SOCKET_ERROR_BLOCK:
				//ϣ첽ģʽ
				m_bCanWrite = FALSE;
				break;
			case SOCKET_ERROR_CLOSE:
				
				//쳣رգٳֵ
				//رһ
				if( m_pClientThread ) 
				{
					m_pClientThread->KillThread();
					m_pClientThread = NULL;
				}
				else
				{
					::PostThreadMessage( m_pServerThread->m_nThreadID,
					SOCKET_THREAD_SHUT, 0, 0 );
				}

				GetDlgItem(IDC_DISCONNECT)->EnableWindow( FALSE );
				GetDlgItem(IDC_CHAT )->EnableWindow(FALSE );
				GetDlgItem(IDC_SEND )->EnableWindow(FALSE );	
				GetDlgItem(IDC_CONNECT)->SetWindowText("");
				GetDlgItem(IDC_FROMIP )->SetWindowText( _T("") );
				GetDlgItem(IDC_YOUNAME)->SetWindowText( _T("") );
				GetDlgItem(IDC_TIME)->SetWindowText( _T("") );

				m_bState = MY_ORIGIN;
				m_bType = IAM_NULL;
				m_bHaveGotName = FALSE;
				m_bCanWrite = FALSE;
				KillTimer( ID_TIMER_CHAT );

				MessageBox( "дʱѾرգԶ", "", MB_OK|MB_ICONSTOP );
				break;
			case SOCKET_ERROR_RESET:
				
				//쳣رգٳֵ
				//رһ
				if( m_pClientThread ) 
				{
					m_pClientThread->KillThread();
					m_pClientThread = NULL;
				}
				else
				{
					::PostThreadMessage( m_pServerThread->m_nThreadID,
					SOCKET_THREAD_SHUT, 0, 0 );
				}

				
				GetDlgItem(IDC_DISCONNECT)->EnableWindow( FALSE );
				GetDlgItem(IDC_CHAT )->EnableWindow(FALSE );
				GetDlgItem(IDC_SEND )->EnableWindow(FALSE );	
				GetDlgItem(IDC_CONNECT)->SetWindowText("");
				GetDlgItem(IDC_FROMIP )->SetWindowText( _T("") );
				GetDlgItem(IDC_YOUNAME)->SetWindowText( _T("") );
				GetDlgItem(IDC_TIME)->SetWindowText( _T("") );

				m_bState = MY_ORIGIN;
				m_bType = IAM_NULL;
				m_bHaveGotName = FALSE;
				m_bCanWrite = FALSE;
				KillTimer( ID_TIMER_CHAT );

				

				MessageBox( "дʱ·ãϷԶ", "", MB_OK|MB_ICONSTOP );

				break;
			default: 
				//ʾ
				
				//쳣رգٳֵ
				//رһ
				if( m_pClientThread ) 
				{
					m_pClientThread->KillThread();
					m_pClientThread = NULL;
				}
				else
				{
					::PostThreadMessage( m_pServerThread->m_nThreadID,
					SOCKET_THREAD_SHUT, 0, 0 );
				}

				GetDlgItem(IDC_DISCONNECT)->EnableWindow( FALSE );
				GetDlgItem(IDC_CHAT )->EnableWindow(FALSE );
				GetDlgItem(IDC_SEND )->EnableWindow(FALSE );	
				GetDlgItem(IDC_CONNECT)->SetWindowText("");
				GetDlgItem(IDC_FROMIP )->SetWindowText( _T("") );
				GetDlgItem(IDC_YOUNAME)->SetWindowText( _T("") );
				GetDlgItem(IDC_TIME)->SetWindowText( _T("") );


				m_bState = MY_ORIGIN;
				m_bType = IAM_NULL;
				m_bHaveGotName = FALSE;
				m_bCanWrite = FALSE;
				KillTimer( ID_TIMER_CHAT );


				CString szTemp;
				szTemp.Format("дʱִ󣬴Ϊ%dϷԶ", nResult );
				MessageBox( szTemp, "", MB_OK|MB_ICONSTOP );
				break;
			}
	}
}

void CChatDlg::AnalyzeData(LPBYTE lpBuffer, int nBytes)
{
	int nResult = nBytes;
	///
	int nAct;
	char temp[256];
	CString szTemp;

	if( lpBuffer == NULL ) return;
	if( nBytes == 0 ) return;
	if( m_bType == IAM_NULL ) return;

	UpdateData();

	//һֽ
	nAct = lpBuffer[0];
	switch( nAct )
	{
	case CHAT_ACT_NULL:
		if( m_bType == IAM_SERVER )
		{
			SendCommand( CHAT_ACT_NULL );
		}
		break;
	case CHAT_ACT_SEND_NAME:
		if( lpBuffer[1] != nBytes ) return;
		memcpy( temp, lpBuffer+2, nBytes-2 );
		temp[nBytes-2] = '\0';
		szTemp = _T(temp );
		m_ctrlChat.SetUser( confChat.szUserName, szTemp );
		GetDlgItem(IDC_CHAT )->SetWindowText( _T("") );
		GetDlgItem( IDC_CHAT )->EnableWindow(TRUE );
		GetDlgItem( IDC_SEND )->EnableWindow(TRUE);
		//޸
		if( m_bType == IAM_SERVER )	
			 GetDlgItem( IDC_FROMIP)->SetWindowText(m_pServerThread->GetHost() );
		else    
			 GetDlgItem( IDC_FROMIP)->SetWindowText(m_pClientThread->GetHost() );
		GetDlgItem( IDC_YOUNAME )->SetWindowText( szTemp );
		//ʱ
		if( m_bHaveGotName == FALSE  )
		{
			if( m_bType == IAM_SERVER )
			{
				SendCommand( CHAT_ACT_SEND_NAME );			
			}
			//Start timer
			SetTimer( ID_TIMER_CHAT, 1000, NULL );
			CTime cStartTime = CTime::GetCurrentTime();
			t_start = cStartTime.GetTime();
		}
		m_bHaveGotName = TRUE;
		break;
	case CHAT_ACT_ASK_SEND:
		if( lpBuffer[1] != nBytes ) return;
		memcpy( temp, lpBuffer+2, nBytes-2 );
		temp[nBytes-2] = '\0';
		m_ctrlChat.PostChat( (LPSTR)temp, FALSE );
		SendCommand( CHAT_ACT_AGREE_SEND );
		break;
	case CHAT_ACT_AGREE_SEND:
		if( m_bState != MY_ASKING ) return;
		m_bState = MY_CONNECTED;
		GetDlgItem(IDC_SEND )->EnableWindow( TRUE );
		break;
	case CHAT_ACT_ASK_TEST:
		SendCommand( CHAT_ACT_AGREE_TEST );
		break;
	case CHAT_ACT_AGREE_TEST:
		if( m_bState != MY_ASKING ) return;
		m_bState = MY_CONNECTED;
		GetDlgItem(IDC_CONNECT )->EnableWindow( TRUE );
		MessageBox("糩ͨ졣" , "ʾ", MB_OK|MB_ICONINFORMATION);
		break;
	case CHAT_ACT_BUSY:
		//if( m_bState != MY_ASKING ) return;
		if( m_pClientThread ) 
		{
			m_pClientThread->KillThread();
			m_pClientThread = NULL;
		}
		GetDlgItem(IDC_DISCONNECT)->EnableWindow( FALSE );
		GetDlgItem(IDC_CHAT )->EnableWindow(FALSE );
		GetDlgItem(IDC_SEND )->EnableWindow(FALSE );	
		GetDlgItem(IDC_CONNECT)->SetWindowText("");
		m_bState = MY_ORIGIN;
		m_bType = IAM_NULL;
		m_bHaveGotName = FALSE;
		MessageBox( "ԷæԺӡ", "ʾ", MB_OK|MB_ICONSTOP );
		break;
	case CHAT_ACT_QUIT:
		if( m_pClientThread ) 
		{
			m_pClientThread->KillThread();
			m_pClientThread = NULL;
		}
		else
		{
			::PostThreadMessage( m_pServerThread->m_nThreadID,
					SOCKET_THREAD_SHUT, 0, 0 );
		}

		GetDlgItem(IDC_DISCONNECT)->EnableWindow( FALSE );
		GetDlgItem(IDC_CHAT )->EnableWindow(FALSE );
		GetDlgItem(IDC_SEND )->EnableWindow(FALSE );	
		GetDlgItem(IDC_CONNECT)->SetWindowText("");
		GetDlgItem(IDC_FROMIP )->SetWindowText( _T("") );
		GetDlgItem(IDC_YOUNAME)->SetWindowText( _T("") );
		GetDlgItem(IDC_TIME)->SetWindowText( _T("") );
		m_bState = MY_ORIGIN;
		m_bType = IAM_NULL;
		m_bHaveGotName = FALSE;
		KillTimer( ID_TIMER_CHAT );

		MessageBox("Է˳ˣԶ", "ʾ", MB_OK );
		break;	
	default: break;
	}
}

void CChatDlg::OnFileAbout() 
{
	// TODO: Add your command handler code here
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();	
}
