// ChatDlg.h : header file
//


#if !defined(AFX_CHATDLG_H__E01BD027_4AA7_11D4_93A3_0000E86DCAD8__INCLUDED_)
#define AFX_CHATDLG_H__E01BD027_4AA7_11D4_93A3_0000E86DCAD8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ChatEdit.h"
#include "ServerThread.h"
#include "ClientThread.h"

#define MY_ORIGIN			0
#define MY_CONNECTED		1
#define MY_ASKING			2


#define IAM_NULL			0
#define IAM_CLIENT			1
#define IAM_SERVER			2

/////////////////////////////////////////////////////////////////////////////
// CChatDlg dialog

class CChatDlg : public CDialog
{
// Construction
public:
	CChatDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CChatDlg)
	enum { IDD = IDD_CHAT_DIALOG };
	CChatEdit	m_ctrlChat;
	CString	m_szChatSend;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChatDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CChatDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnFileExit();
	afx_msg void OnFileOption();
	afx_msg void OnFileSave();
	virtual void OnOK();
	afx_msg void OnConnect();
	afx_msg void OnSend();
	afx_msg void OnDisconnect();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnClientAccept(WPARAM wParam, LPARAM lParam);
	afx_msg void OnThreadQuit(WPARAM wParam, LPARAM lParam);
	afx_msg void OnThreadData(WPARAM wParam, LPARAM lParam);
	afx_msg void OnThreadWrite(WPARAM wParam, LPARAM lParam);
	afx_msg void OnTransfer(WPARAM wParam, LPARAM lParam);
	afx_msg void OnFileAbout();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	time_t t_start;
	BOOL m_bHaveGotName;
	void SendCommand(int nAct, int nBytes=0, LPCTSTR lpszChat=NULL);
	void AnalyzeData(LPBYTE lpBuffer, int nBytes);
	void InitProfile();
	void WriteProfile();
	void GetLocalIP();
	void OnCancel();


	BOOL	m_bCanWrite;		//Ƿд
	BOOL	m_bType;			//ͣ(ͻͷ)
	int		m_bState;			//Ŀǰ״̬
	LPBYTE	m_lpReceiveBuffer;	//
	LPBYTE	m_lpSendBuffer;		//
	
	CClientThread *m_pClientThread;
	CServerThread *m_pServerThread;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHATDLG_H__E01BD027_4AA7_11D4_93A3_0000E86DCAD8__INCLUDED_)
